//
//  MTSOAP.m
//  MTPPSCRASample
//
//  Created by Tam Nguyen on 6/2/16.
//  Copyright © 2016 MagTek. All rights reserved.
//

#import "MTSOAP.h"
#import "XMLDictionary.h"
@implementation MTSOAP


+ (NSString*)calculateMAC:(NSString*)ksn data:(NSString*)data type:(NSString*)type derivedData:(NSString*)derivedData
{
    
    
    
    NSString* post =[NSString stringWithFormat: @"<soapenv:Envelope xmlns:soapenv=\"http://schemas.xmlsoap.org/soap/envelope/\" xmlns:mth=\"http://mthsmws.magtek.com/\">"
                     "<soapenv:Header/>"
                     "<soapenv:Body>"
                     "<mth:CalculateCBCMAC>"
                     "<mth:oMACOperationInputs>"
                     "<mth:KeyName>Test/BDK%@</mth:KeyName>"
                     "<mth:KeyDerivationType>%@</mth:KeyDerivationType>"
                     "<mth:KeyDerivationData>%@</mth:KeyDerivationData>"
                     "<mth:KSN>%@</mth:KSN>"
                     "<mth:Message2MAC>%@</mth:Message2MAC>"
                     "</mth:oMACOperationInputs>"
                     "</mth:CalculateCBCMAC>"
                     "</soapenv:Body>"
                     "</soapenv:Envelope>", [@"9500030" substringToIndex:7], type, derivedData ,ksn, data] ;
    
    NSData* postData =[post dataUsingEncoding: NSUTF8StringEncoding];
    //NSString* postLength = [NSString stringWithFormat:@"%d", (int)postData.length];
    NSMutableURLRequest* request = [[NSMutableURLRequest alloc]initWithURL:[NSURL URLWithString:@"http://10.57.10.52/mthsmws/mthsmservice.asmx"] cachePolicy:NSURLRequestReloadIgnoringCacheData timeoutInterval:20];
    //    request.HTTPMethod = @"POST";
    //    [request setValue:postLength forKey:@"Content-Length"];
    //     [request setValue:@"text/xml;charset=utf-8" forKey:@"Content-Type"];
    //    [request setValue:@"http://mthsmws.magtek.com/CalculateCBCMAC" forKey:@"SOAPAction"];
    NSMutableDictionary *headers = [NSMutableDictionary dictionaryWithCapacity:0];
    [headers setObject:@"text/xml" forKey:@"Content-Type"];
    [headers setObject:@"utf-8" forKey:@"charset"];
    [headers setObject:@"tr" forKey:@"Lang"];
    [headers setObject:@"http://mthsmws.magtek.com/CalculateCBCMAC" forKey:@"SOAPAction"];
    [headers setObject:@"Mac OS X; WebServicesCore.framework (1.0.0)" forKey:@"User-Agent"];
    
    [request setAllHTTPHeaderFields:headers];
    [request setHTTPMethod:@"POST"];
    
    request.HTTPBody = postData;
    NSError* error;
    NSData* returnData = [NSURLConnection sendSynchronousRequest:request returningResponse:nil error:&error];
    NSDictionary* returnDict = [NSDictionary dictionaryWithXMLData:returnData];
    if( [returnDict valueForKeyPath:@"soap:Body.CalculateCBCMACResponse.CalculateCBCMACResult.MAC"])
    {
        NSString* rs = [returnDict valueForKeyPath:@"soap:Body.CalculateCBCMACResponse.CalculateCBCMACResult.MAC"];
        return rs;
    }
    return @"";
}

@end
