//
//  NSObject+TLVParser.h
//  MTEMVDemo
//
//  Created by Tam Nguyen on 7/15/15.
//  Copyright © 2015 MagTek. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "HexUtility.h"


@interface MTTLVObject : NSObject
@property (nonatomic, strong) NSString* tag;
@property (nonatomic) int length;
@property (nonatomic, strong) NSString* value;

@end

@interface NSData (TLVParser)
- (NSMutableDictionary*) parseTLVData;
@end


@interface NSMutableDictionary (MTTLVList)

-(MTTLVObject*)getTLV;
- (NSString*) dumpTags;
@end