//
//  MTDataViewerViewController.h
//  MTSCRADemo
//
//  Created by Tam Nguyen on 7/21/15.
//  Copyright (c) 2015 MagTek. All rights reserved.
//

#import <UIKit/UIKit.h>
#import "AppDelegate.h"
#import "MTPPSCRA.h"
#import "MTSigController.h"
#import "MTCustomRadio.h"
@protocol emvMemuProtocol <NSObject>
@optional
-(void)didSelectMenu:(int)index;

@end

@interface emvOptionMenu : UITableViewController
@property (nonatomic, weak) id <emvMemuProtocol> delegate;
@property (strong, nonatomic) NSMutableArray* menuArray;
@end

@interface MTDataViewerViewController : UIViewController < UITextFieldDelegate,UIPopoverPresentationControllerDelegate, emvMemuProtocol, MTPPSCRADelegate, UITextViewDelegate >
{
    //NSString *_deviceSerialNumber;
    //NSData* datad;
}
//- (void)connect;

@property (nonatomic, strong) UIButton* btnConnect ;
@property (nonatomic, strong) UIButton* btnSendCommand ;
@property (nonatomic, strong) UITextView* txtData;
@property (nonatomic, strong) UITextField* txtCommand;
@property (strong, nonatomic) NSMutableArray *processTypeMutablearray;
@property (nonatomic, strong) UIButton* btnStartEMV;
@property (nonatomic, strong) UIButton* endSession;
@property (nonatomic, strong) UIButton* btnCancel;

@property (nonatomic, strong) MTCustomRadio* msr;
@property (nonatomic, strong) MTCustomRadio* chip;
@property (nonatomic, strong) MTCustomRadio* contactless;
@property (nonatomic, strong) MTCustomRadio* quickChip;
- (void) setText:(NSString*)text;
-(void) onConnectionStateChanged:(ConnectionType)connectionType state:(ConnectionState)state;
@end
