//
//  emvControllerBLE.m
//  MTPPSCRASampleV2
//
//  Created by Tam Nguyen on 2/3/16.
//  Copyright © 2016 None. All rights reserved.
//

#import "emvControllerBLE.h"


@implementation emvControllerBLE

- (void)viewDidLoad {
    [super viewDidLoad];
    
    self.title = @"Bluetooth LE";
    
    
    [self.btnConnect removeTarget:nil action:NULL forControlEvents:UIControlEventTouchUpInside];
    
    [self.btnConnect addTarget:self action:@selector(connectToDPMini) forControlEvents:UIControlEventTouchUpInside];
    
    
   
    
    [self.contactless setSelected:NO];
}

-(void)deviceNotPaired
{
    NSLog(@"Device not paired");
}
-(void) onConnectionStateChanged:(ConnectionType)connectionType state:(ConnectionState)state
{
    [super onConnectionStateChanged:connectionType state:state];
}

-(void)connectToDPMini
{
    if(![MTPPSCRA sharedInstance].isDeviceConnected)
    {
        BLEScannerList* list = [BLEScannerList new];
        list.delegate = self;
        [self.navigationController pushViewController:list animated:YES];
    }
    else
    {
        [[MTPPSCRA sharedInstance]closeDevice];
    }
}

- (void)didSelectBLEReader:(NSString *)perUUID
{
        [self.navigationController popViewControllerAnimated:YES];
        [[MTPPSCRA sharedInstance] setConnectionType:BLEEMV];
        [[MTPPSCRA sharedInstance] setAddress:perUUID];
        [[MTPPSCRA sharedInstance] openDevice];
}
-(void)viewDidAppear:(BOOL)animated
{
     [MTPPSCRA sharedInstance].delegate = self;
}


@end
