//
//  emvControllerUART.m
//  MTPPSCRASample
//
//  Created by Tam Nguyen on 6/15/16.
//  Copyright © 2016 MagTek. All rights reserved.
//

#import "emvControllerUART.h"

@implementation emvControllerUART
- (void)viewDidLoad {
    [super viewDidLoad];
    
    self.title = @"UART";
    
    
    [self.btnConnect removeTarget:nil action:NULL forControlEvents:UIControlEventTouchUpInside];
    
    [self.btnConnect addTarget:self action:@selector(connectToDPMini) forControlEvents:UIControlEventTouchUpInside];
    
    
    [MTPPSCRA sharedInstance].delegate = self;
    
    
}
-(void) onConnectionStateChanged:(ConnectionType)connectionType state:(ConnectionState)state
{
    [super onConnectionStateChanged:connectionType state:state];
}

-(void)connectToDPMini
{
    if(![[MTPPSCRA sharedInstance]isDeviceConnected])
    {
        [[MTPPSCRA sharedInstance]setAddress:@"com.magtek.dynapromini"];
        [[MTPPSCRA sharedInstance]openDevice];
    }
    else
    {
        [[MTPPSCRA sharedInstance]closeDevice];
    }
}

- (void)didSelectBLEReader:(NSString *)perUUID
{
    [self.navigationController popViewControllerAnimated:YES];
    [[MTPPSCRA sharedInstance] setConnectionType:BLEEMV];
    [[MTPPSCRA sharedInstance] setAddress:perUUID];
    [[MTPPSCRA sharedInstance] openDevice];
}
-(void)viewDidAppear:(BOOL)animated
{
     [MTPPSCRA sharedInstance].delegate = self;
}

@end
